Status: Rejected Start date: 11/29/2012
Priority: Normal Due date:
Assignee: J. Moringen % Done: 80%
Category: Estimated time: 0.00 hour
Target version: rsb-0.9
Description

    -  change unit to seconds
    -  change type to double

Related issues:
Related to Robotics Systems Types - Tasks # 1271: Change rst.timing.Duration.... Rejected 11/29/2012

History
#1 - 11/30/2012 11:05 AM - A. Swadzba

Um das zu tun, müsste ich mir den rst-0.8 branch auschecken, oder?

#2 - 11/30/2012 02:37 PM - J. Moringen

This issue is intended to collect opinions. The actual change, if any, can be done later.

#3 - 11/30/2012 03:38 PM - A. Swadzba

In principal possible, but would effect existing source code.

#4 - 11/30/2012 03:44 PM - J. Moringen

Other opinions?

I brought this up because we mostly use SI units.

#5 - 11/30/2012 07:49 PM - J. Moringen
- Assignee changed from A. Swadzba to J. Moringen
- % Done changed from 0 to 80

We discussed this and it seems better to keep the current definition. Sorry.

There were four major arguments:

SI Units
In favor of change: We try to use SI units without magnitude prefixes, wherever possible.

Precision
Inconclusive: Experiments show that, in general, uint64 and double-float, but not single-float, provide enough precision for accurate timestamp
calculation:

CL-USER> (let* ((now    (local-time:now))
                (a/sec  (local-time:timestamp-to-unix now))
                (a/nsec (local-time:nsec-of now))

                (ai     (+ (* 1000000 a/sec) (floor a/nsec 1000)))
                (af     (float ai 1.0f0)) ; single float
                (ad     (float ai 1.0d0)) ; double float

                (bi     (+ (* 1000000 0) (+ (floor a/nsec 1000) 1)))
                (bf     (float bi 1.0f0)) ; single float
                (bd     (float bi 1.0d0)) ; double float
                )
           (format t "Integer   ~20D   - ~20D   = ~20D~%Single Float~20F -   ~20F =   ~20F~%Double Float~20F -   ~20F =   ~20F~%" 
                   bi ai (- ai bi) 
                   bf af (- af bf)
                   bd ad (- ad bd)))
Integer                 166762   -     1354300814166761   =     1354300813999999
Single Float            166762.0 -     1354300800000000.0 =     1354300800000000.0
Double Float            166762.0 -     1354300814166761.0 =     1354300813999999.0

Efficiency
Against change: In most cases, manipulation of integers is more efficient than manipulation of floats.

Common Practice
Against change: It was our impression that in most related work, timestamps are represented as integer/msec or integer/µsec.

Conclusion
We came to the conclusion that it would be best to keep the uint64/µsec representation and convert to float/sec in clients who want this (maybe with
support from project:rosetta).

If nobody objects, I would add this explanation/rationale to the documentation strings of the data type and reject the issue.

#6 - 12/03/2012 06:29 PM - J. Moringen
- Status changed from Feedback to Rejected
